<!DOCTYPE html>
<html>
<head>
	<title>hello</title>
</head>
<body>
	<h1>Strings</h1>
	<p id="demo">Strings lecture</p>

	<script type="text/javascript">
		var text = "john Doe";
		var text2 = "john Doe";
		console.log("length of var2 is " + text2.length);

		//Strings can also be objects.
		var text3 = "john doe";	//string variable
		var x = new String("john doe"); //the string is object
		console.log(text3,x);
		console.log(typeof text3 + "is the type of text3 variable");
		console.log(typeof x + "is the type of x variable");
		console.log( "is the comparison result of text3 == x"+ x==text3 );
		console.log(x===text3 + "is the comparison result of text3 === x");
		//if we declare string as object we cannot compare them.

		//difference between == and === is that === will compare the value as well as the data type.

		console.log("\n\n\nSTRING METHODS\n\n\n")
		var text4 = "find me if you can me";
		console.log(text4.length + " is the length of the string");
		console.log("me word is at position - " + text4.indexOf("me"));	
		console.log("me word's last position - " + text4.lastIndexOf("me"));
		//if a word is not present in the string the result will be -1
		console.log("me word is at position using search - " + text4.search("me"));
		//slice(start, end)
		console.log("\n\nslice(start, end)\n")
		var fruits = "Apple, Banana, Kiwi";
		console.log('slice in action - ' + fruits.slice(7,13));
		console.log('slice in action - ' + fruits.slice(7));
		console.log('slice in action with -ve parameter - ' + fruits.slice(-12, -6));
		
		//substring(start, end)
		console.log("\n\nsubstring(start, end)\n");
		console.log('substring in action - ' + fruits.substring(7,13));

		//substr(start, length)
		console.log("\n\nsubstr(start, length)\n");
		console.log('substr in action - ' + fruits.substr(7,6));

		//replace()
		console.log("\n\nreplace(old, new)\n");
		console.log(fruits.replace("Kiwi", "Orange"));

		//toLowerCase()
		console.log("\n\ntoLowerCase()\n");
		console.log(fruits.toLowerCase());

		//toUpperCase()
		console.log("\n\ntoUpperCase()\n");
		console.log(fruits.toUpperCase());

		var x = "Hello";
		var y = "World";
		var z1 = x.concat(" ",y);
		var z2 = x + " " + y;
		console.log("z1 = " + z1 + "\nz2 = " + z2);


		//Extracting characters
		console.log("Char at index 4 is : " + fruits.charAt(4));
		console.log("Character code of character at index 4 is : " + fruits.charCodeAt(4));

		//split(delimiter)
		var fruitsArray = fruits.split(',');
		console.log(fruitsArray);
		//if no seperator specified then the array will have entire string at index 0 of the array

	</script>
</body>
</html>